<template>
  <div class="product-list">
    <v-container grid-list-xl fluid>
      <v-layout row wrap>
        <v-col cols="12" class="d-flex align-center justify-space-between">
          <h1>Statistiques de l'entreprise</h1>
        </v-col>

        <v-col class="d-flex" cols="10">
          <v-select :items="stores" v-model="selected" label="Sélectionnez une entreprise"></v-select>
        </v-col>

        <v-col cols="12">
          <div>{{selected}}</div>
        </v-col>
      </v-layout>
    </v-container>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import ListMixin from "../../../mixins/ListMixin";

export default {
  name: "AdminStatList",
  servicePrefix: "AdminStat",
  mixins: [ListMixin],
  components: {},
  data() {
    return {
      selected: {}
    };
  },
  computed: {
    ...mapFields("admin", ["company", "companyFound"]),
    ...mapFields("user", ["userInfos", "loggedIn"]),
    stores() {
      if (this.company.stores != undefined) {
        return this.company.stores.map(store => this.fullLocation(store));
      }
      return [];
    }
  },
  created() {
    if (this.userInfos) {
      this.getProfile(this.userInfos.id);
    }
  },
  watch: {
    selected(store) {
      this.selected = this.company.stores.find(
        s => this.fullLocation(s) == store
      );
    },
    // company.stores.flatMap(store => store.products)
    companyFound(newData) {
      if (newData) {
        this.getStoresByCompany(this.company.id);
      }
    },
    userInfos(newData) {
      if (newData) {
        this.getCompany(newData.company["@id"].split("/")[2]);
      }
    }
  },
  methods: {
    fullLocation(item) {
      return item.street + " - " + item.zc + item.city + ", " + item.country;
    },
    ...mapActions("adminProduct", {
      getPage: "fetchAll",
      deleteItem: "del"
    }),
    ...mapActions("product", ["setProductLoadedState"]),
    ...mapActions("admin", ["getCompany", "getStoresByCompany"]),
    ...mapActions("user", ["getProfile"]),
    productCompany(item) {
      return this.company.stores.find(store =>
        store.products.find(product => product.id == item.id)
      );
    },
    customSort(items, index, isDescending) {
      items.sort((a, b) => {
        if (index === "store") {
          if (isDescending) {
            return b.store.id - a.store.id;
          } else {
            return a.store.id - b.store.id;
          }
        }
      });
      return items;
    }
  }
};
</script>
